/*
 * serial-common.c
 *
 *  Created on: 23/12/2009
 *      Author: ivan
 */
#include "serial.h"

int serial_read_bytes(serial_t * serial, void * buff, int length)
{
	return serial_read_bytes_retrys(serial, buff, length, 2, 200);
}

int serial_read_bytes_retrys(serial_t * serial, void * buff, int length, int retries, long tout)
{
	int readed = 0, tmp,i = 0;
	while ((readed < length) && (i < retries)) {
			tmp = serial_read(serial, buff + readed, length - readed, tout);
			if(tmp < 0) return -1;
			if(tmp == 0) i++;
			readed+=tmp;
		}
	return readed;
}
int serial_write_bytes_retrys(serial_t * serial, void * buff, int length, int retries)
{
	int written = 0, tmp,i = 0;
	while ((written < length) && (i < retries)) {
			tmp = serial_write(serial, buff + written, length - written);
			if(tmp < 0) return -1;
			if(tmp == 0) i++;
			written+=tmp;
		}
	return written;
}

int serial_write_bytes(serial_t * serial, void * buff, int length)
{
	return serial_write_bytes_retrys(serial, buff, length, 1);
}
