/*
 * sign.c
 *
 *  Created on: Nov 19, 2008
 *      Author: joangs
 */

#include <string.h>
#include <glib.h>
#include "../../md5lib/md5.h"

#define KEY "enjutomojamuto"
#define KEY2 0x00ab395f

char *printer_sign(char *key, int id, int pagines, int color)
{
	char md5_f1[16];
	char bufo[33];
	gchar *buf;
	md5_t md5;

	buf = g_strdup_printf("%s:%s:%d:%d:%d", KEY, key, id, pagines, color);
	md5_init(&md5);
	md5_process(&md5, buf, strlen(buf));
	md5_finish(&md5, md5_f1);
	md5_sig_to_string(md5_f1, bufo, 33);

	return strdup(bufo);
}

inline int getValue4Char (char c)
{
	if(c == 45) return 0;
	if(c == 46) return 1;
	if((c >= 48) && (c <= 57)) return 2 + (c - '0');
	if((c >= 65) && (c <= 90)) return 12 + (c - 'A');
	if((c >= 97) && (c <= 122)) return 38 + (c - 'a');
	return 0;
}

inline char getChar4Value (int v)
{
	if(v == 0) return 45;
	if(v == 1) return 46;
	if((v >= 2) && (v <= 11)) return '0' + (v - 2);
	if((v >= 12) && (v <= 37)) return 'A' + (v - 12);
	if((v >= 38) && (v <= 63)) return 'a' + (v - 38);
	return '0';
}

char * sms_password_encode (char* org)
{
	int l1 = strlen(org);
	int l2 = l1 + (3 - ((l1 -1)%4)) + 1;
	char *res = (char*) malloc(sizeof(char)*(l2+1));
	int i,j;

	res[0] = '1' + (3 - ((l1 -1)%4));
	for(i = 0; i < l1; i+=4) {
		int v=0;
		for (j = 0; j < 4; j++) {
			v = (v<<6);
			if((i+j) < l1) v+= getValue4Char(org[i+j]);
		}
		v ^= KEY2;
		for (j = 0; j < 4; j++) {
			res[i+j+1] = getChar4Value((v>>(6*(3-j))) & 0x03F);
		}
	}
	res[l2]=0;
	return res;
}

char * sms_password_decode (char* org)
{
	int l1 = strlen(org);
	int l2 = l1 - (org[0] - '0');
	char *res = (char*) malloc(sizeof(char)*(l2+1));
	int i,j;

	for(i = 1; i < l1; i+=4) {
		int v=0;
		for (j = 0; j < 4; j++) {
			v = (v<<6);
			 v+= getValue4Char(org[i+j]);
		}
		v ^= KEY2;
		for (j = 0; j < 4; j++) {
			if((i+j-1) < l1) res[i+j-1] = getChar4Value((v>>(6*(3-j))) & 0x03F);
		}
	}
	res[l2]=0;
	return res;
}
