#ifndef __TELMICOM_H__
#define __TELMICOM_H__
#include "serial.h"

#define TELMICOM_ERR_IO -1
#define TELMICOM_ERR_CHECKSUM -2
#define TELMICOM_ERR_ADDRESS -2

struct telmicom_data {
	unsigned char dst;
	unsigned char org;
	unsigned char cmd;
	unsigned char len;
	unsigned char data[256];
	unsigned char cs;
};

typedef struct telmicom_data telmicom_data_t;

int telmicom_sendcommand(serial_t * serial, telmicom_data_t* command, telmicom_data_t* response);
void print_telmicom_data(const char * label, const telmicom_data_t* command);
int telmicom_moneda(serial_t * serial, unsigned char org, unsigned char dst);
int telmicom_temps(serial_t * serial, unsigned char org, unsigned char dst);
int telmicom_settemps(serial_t * serial, unsigned char org, unsigned char dst, int segons);
double telmicom_get_tarifa(serial_t * serial, unsigned char org, unsigned char dst);
int telmicom_set_tarifa(serial_t * serial, unsigned char org, unsigned char dst, double tarifa);
int telmicom_descuento(serial_t * serial, unsigned char org, unsigned char dst, int activar);
int telmicom_set_tarifa(serial_t * serial, unsigned char org, unsigned char dst, double tarifa);
int telmicom_descuento(serial_t * serial, unsigned char org, unsigned char dst, int activar);
int telmicom_setText(serial_t * serial, unsigned char org, unsigned char dst, const char * text);
int telmicom_setFuncionesOciomatik(serial_t * serial, unsigned char org, unsigned char dst,
		int activarReset, int tempsReset, int activarWatchdog, int tempsWatchdog,
		int activarPower, int tempsPower);
int telmicom_setMonedes(serial_t * serial, unsigned char org, unsigned char dst, int monedes[]);
int telmicom_getFuncionesOciomatik(serial_t * serial, unsigned char org, unsigned char dst,
		int *activarReset, int *tempsReset, int *activarWatchdog, int *tempsWatchdog,
		int *activarPower, int *tempsPower);
int telmicom_getMonedes(serial_t * serial, unsigned char org, unsigned char dst, int *monedes);
int telmicom_inhabilita(serial_t * serial, unsigned char org, unsigned char dst, int inhabilita);
int telmicom_getText(serial_t * serial, unsigned char org, unsigned char dst, char * text);
#endif
