#!/bin/sh
for i in `echo $QUERY_STRING |sed 's/[&]/\n/g'`; do export QUERY_$i ; done

escapehost()
{
	echo $1 | sed "s/[^[:alnum:].-]//g"
}

if [ -n "$QUERY_update" ] ; then 
	cp /etc/sysconfig/network-scripts/ifcfg-eth0 /tmp/ifcfg-eth0	
	#Configurem el nom de la maquina
	(
		echo "NETWORKING=yes"
		echo HOSTNAME=`escapehost "$QUERY_hostname"` 
	)> /etc/sysconfig/network

	if [ "$QUERY_dhcp" != "yes" ]; then
		## Configurem la IP
		(
			grep "^#" < /tmp/ifcfg-eth0
			grep DEVICE < /tmp/ifcfg-eth0
			grep HWADDR < /tmp/ifcfg-eth0
			grep ONBOOT < /tmp/ifcfg-eth0
			grep TYPE < /tmp/ifcfg-eth0
			echo BOOTPROTO=none
			echo IPADDR=`escapehost "$QUERY_ip"`
			echo NETMASK=`escapehost "$QUERY_netmask"`
			echo GATEWAY=`escapehost "$QUERY_gw"`
		) > /etc/sysconfig/network-scripts/ifcfg-eth0

		## Configurem els DNS
		(
			if [ -n "$QUERY_dns1" ]; then echo nameserver $QUERY_dns1 ; fi
			if [ -n "$QUERY_dns2" ]; then echo nameserver $QUERY_dns2 ; fi
		) > /etc/resolv.conf
	else
		(
			grep "^#" < /tmp/ifcfg-eth0
			grep DEVICE < /tmp/ifcfg-eth0
			grep HWADDR < /tmp/ifcfg-eth0
			grep ONBOOT < /tmp/ifcfg-eth0
			grep TYPE < /tmp/ifcfg-eth0
			echo BOOTPROTO=dhcp
		) > /etc/sysconfig/network-scripts/ifcfg-eth0
	fi
fi

. /etc/sysconfig/network
. /etc/sysconfig/network-scripts/ifcfg-eth0

j=1
export DNS1=""
export DNS2=""
for i in `cat /etc/resolv.conf |grep nameserver|cut -f 2 -d " "`; do
	export DNS$j=$i
	j=$(( $j + 1 ))
done
echo Content-Type: text/html
echo
echo "<html>"
echo "<head><link rel='stylesheet' type='text/css' href='/ociomatik.css' /><title>Ociomatik printer config</title></header>"
echo "<body>"
echo "<form name='frm' method='get'>"
cat /var/www/lighttpd/header.html
echo "<table>"
echo "<tr class='head'><td class='key'></td><td class='value'></td>"
echo "<tr class='content'><td class='key'>Hostname</td><td class='value'><input type='text' name='hostname' value='$HOSTNAME'></td>"
echo "<tr class='content'><td class='key'>DHCP</td><td class='value'>"
echo "<input type='radio' name='dhcp' value='yes'" 
if [ -z "$IPADDR" ]; then
	echo checked 
fi
echo " onclick='shIPcfg()'> Yes"
echo "<input type='radio' name='dhcp' value='no'"
if [ -n "$IPADDR" ]; then echo checked ; fi
echo " onclick='shIPcfg()'> No"
"</td>"
if [ -z "$IPADDR" ]; then
	IPADDR=`/sbin/ifconfig eth0 |grep "inet addr"|sed "s/^.*inet addr:\([[:digit:].]*\).*$/\1/g"`
	NETMASK=`/sbin/ifconfig eth0 |grep "inet addr"|sed "s/^.*Mask:\([[:digit:].]*\).*$/\1/g"`
	GATEWAY=`/sbin/route -n |grep ^0.0.0.0 |sed "s/[ \t][ \t]*/ /g" |cut -f 2 -d " "`
fi
echo "<tr class='content' id='ip'><td class='key'>IP ADDRESS</td><td class='value'><input type='text' name='ip' value='$IPADDR'></td>"
echo "<tr class='content' id='netmask'><td class='key'>NETMASK</td><td class='value'><input type='text' name='netmask' value='$NETMASK'></td>"
echo "<tr class='content' id='gw'><td class='key'>GATEWAY</td> <td class='value'><input type='text' name='gw' value='$GATEWAY'></td>"
echo "<tr class='content' id='dns1'><td class='key'>DNS 1</td><td class='value'><input type='text' name='dns1' value='$DNS1'></td>"
echo "<tr class='content' id='dns2'><td class='key'>DNS 2</td><td class='value'><input type='text' name='dns2' value='$DNS2'></td>"
echo "<tr class='foot'><td></td><td><input type='submit' name='update' value='Ok'></td></tr>"
echo "</table>"
echo "</form>"

echo "<script type='text/javascript'>"
echo "function shIPcfg() {
	var dhcp = ((document.frm.dhcp[0].value == 'yes' && document.frm.dhcp[0].checked) || (document.frm.dhcp[1].value == 'yes' && document.frm.dhcp[1].checked))
/*	var dis = dhcp?"none":""
	document.getElementById('ip').style.display = dis
	document.getElementById('netmask').style.display = dis
	document.getElementById('gw').style.display = dis
	document.getElementById('dns1').style.display = dis
	document.getElementById('dns2').style.display = dis
*/
	document.frm.ip.disabled=dhcp
	document.frm.netmask.disabled=dhcp
	document.frm.gw.disabled=dhcp
	document.frm.dns1.disabled=dhcp
	document.frm.dns2.disabled=dhcp
}"
echo "shIPcfg()"
echo "</script>"
if [ -n "$QUERY_update" ] ; then 
	echo "<span style='color:red'>Applying new configuration. Please Wait 30 seconds.</span>"
fi
echo "</body>"
echo "</html>"
if [ -n "$QUERY_update" ] ; then 
	sudo /sbin/service network restart >/tmp/ipchange.log 2>&1
fi
