#!/bin/sh
echo Content-Type: text/html
echo

regenTeaConfig()
{
	(
		cat <<EOF		
[global]
debug : yes
directory : /var/spool/cups/
EOF
		for i in /etc/printers.d/* ; do 
			. $i
			echo
			echo "[$PRINTER_NAME]"
			echo 'prehook_00ociomatik : /usr/local/sbin/sendpages $TEACLIENTHOST $TEAJOBID '$PRINTER_PRICE' `pkpgcounter $TEADATAFILE` $TEACOPIES'
		done
	) > /etc/cups/tea4cups.conf
}

for i in `echo $QUERY_STRING |sed 's/[&]/\n/g'`; do export "QUERY_`echo $i|/var/www/lighttpd/cgi/uridecode.pl`" ; done
#env |sort |sed 's/$/<br>/g'
escapehost()
{
	echo $1 | sed "s/[^[:alnum:].-]//g"
}
if [ -n "$QUERY_New" ] ; then QUERY_PRINTER=`echo $QUERY_NAME |sed 's/[^[:alnum:]._-]//g'` ; fi
if [ -n "$QUERY_Apply" ] || [ -n "$QUERY_New" ] ; then 
	(
		echo "PRINTER_NAME='$QUERY_PRINTER'"
		echo "PRINTER_INFO='$QUERY_INFO'"
		echo "PRINTER_URI='$QUERY_URI'"
		echo "PRINTER_LOCATION='$QUERY_LOCATION'"
		echo "PRINTER_DRIVER='$QUERY_DRIVER'"
		echo "PRINTER_MARCA='$QUERY_MARCA'"
		echo "PRINTER_MODEL='$QUERY_MODEL'"
		echo "PRINTER_PRICE='$QUERY_PRICE'"
		#echo "PRINTER_=$QUERY_"
	) >"/etc/printers.d/$QUERY_PRINTER"
	
	sudo /usr/sbin/lpadmin -p "$QUERY_PRINTER" -m "$QUERY_DRIVER" -v "tea4cups:$QUERY_URI" -L "$QUERY_LOCATION" -o printer-error-policy=abort-job -o printer-is-shared=true -D "$QUERY_INFO" -u allow:all 
	sudo /usr/sbin/cupsenable "$QUERY_PRINTER"
	sudo /usr/sbin/accept "$QUERY_PRINTER"
	regenTeaConfig
fi
if [ -n "$QUERY_Del" ] ; then 
	rm "/etc/printers.d/$QUERY_PRINTER"
	sudo /usr/sbin/lpadmin -x "$QUERY_PRINTER"
	regenTeaConfig
fi

echo "<html>"
echo "<head><link rel='stylesheet' type='text/css' href='/ociomatik.css' /><title>Ociomatik printer config</title></header>"
echo "<body>"
cat /var/www/lighttpd/header.html
cat <<EOF
<script type='text/javascript'>
function selectCombo(sel,val)
{
	var i
	for (i=0; i < sel.length; i++ ) {
		if (sel[i].value == val) {
			sel.selectedIndex=i
			return
		}
	}
}

function updateCombo(idCombo, url, idCombo2, model, driver)
{
	var xmlHttp;
	try {
		// Firefox, Opera 8.0+, Safari
 		xmlHttp=new XMLHttpRequest();
 	} catch (e) {
		// Internet Explorer
		try {
			xmlHttp=new ActiveXObject("Msxml2.XMLHTTP");
		} catch (e) {
			try {
				xmlHttp=new ActiveXObject("Microsoft.XMLHTTP");
			} catch (e) {
				alert("Your browser does not support AJAX!");
				return false;
			}
		}
	}
	xmlHttp.onreadystatechange=function()
	{
		var printerDrivers = new Array()
		var printerDescriptions = new Array()
		var printerModels = new Array()
		printerDrivers.add=function(val) {this[this.length]=val }
		printerDescriptions.add=function(val) {this[this.length]=val }
		printerModels.add=function(val) {this[this.length]=val }
		if(xmlHttp.readyState==4) {
			eval(xmlHttp.responseText)
			var select = document.getElementById(idCombo)
			select.length = 0
			for(var i=0; i < printerDrivers.length; i++) {
				var opt = new Option
				opt.text = printerDescriptions[i]
				opt.value = printerDrivers[i]
				select[i]=opt
				if (opt.value == driver) select.selectedIndex = i
			}
			for(var i=0; i < printerModels.length; i++) {
				var opt = new Option
				opt.text = printerModels[i]
				opt.value = printerModels[i]
				select[i]=opt
				if (opt.value == model) select.selectedIndex = i
			}
			//console.log(idCombo2)
			if(idCombo2 != null) updateComboDrivers(idCombo2, driver)
		}
	}
	xmlHttp.open("GET", url,true);
	xmlHttp.send(null);	
}

function updateComboModels(idx, model, driver)
{
	//console.log("updateComboModels("+idx+")")
	var combo1 = document.getElementById('MARCA_'+idx)
	var idx1 = combo1.selectedIndex
	if (!idx1) idx1=0;
	updateCombo('MODEL_'+idx,'/drivers/'+unescape(combo1[idx1].value).replace(/[^\w.,-]/g,"_") + '.js', idx, model, driver)
}

function updateComboDrivers(idx, driver)
{
	var combo1 = document.getElementById('MARCA_'+idx)
	var combo2 = document.getElementById('MODEL_'+idx)
	var idx1 = combo1.selectedIndex
	var idx2 = combo2.selectedIndex
	if (!idx1) idx1=0;
	if (!idx2) idx2=0;
	updateCombo('DRIVER_' + idx, '/drivers/' + unescape(combo1[idx1].value).replace(/[^\w.,-]/g,"_") + '/' + unescape(combo2[idx2].value).replace(/[^\w.,-]/g,"_") + '.js', null, driver)
}
function selectDriver(id,marca, model,driver)
{
	//console.log("selectDriver("+id+","+marca+","+model+","+driver+")")
	selectCombo(document.getElementById('MARCA_'+id), marca)
	updateComboModels(id, model, driver)
	//updateCombo('MODEL_'+id,'/drivers/'+unescape(marca).replace(/[^\w.,-]/g,"_") + '.js', id, model, driver)
}
</script>
EOF
echo "<h1>Printers:</h1>"
j=0
for i in /etc/printers.d/* ; do 
	if [ $i != '/etc/printers.d/*' ]; then 
		. $i
		echo "<form name='frm$j' method='get'>"
		echo "<fieldset><legend>$PRINTER_NAME</legend><input type='hidden' name='PRINTER' value='$PRINTER_NAME'>"
		echo "Info: <input type='text' name='INFO' value='$PRINTER_INFO'><br>"
		echo "Device URI: <input type='text' name='URI' value='$PRINTER_URI'><br>"
		echo "Location: <input type='text' name='LOCATION' value='$PRINTER_LOCATION'><br>"
		echo "Driver: <select name='MARCA' id='MARCA_$j' onchange='updateComboModels($j)'>"
		cat /var/www/lighttpd/drivers/companies.html
		echo "</select>"
		echo "<select name='MODEL' id='MODEL_$j' onchange='updateComboDrivers($j)'>"
		echo "</select>"
		echo "<select name='DRIVER' id='DRIVER_$j'>"
		echo "</select><br>"
		echo "Price Per Page:  <input type='text' name='PRICE' value='$PRINTER_PRICE'> &euro; cents<br>"
		echo "<input type='submit' name='Apply' value='Apply Changes'> <input type='submit' name='Del' value='Remove Printer'>"
		echo "</fieldset></form>"
		echo "<script type='text/javascript'> selectDriver($j,'$PRINTER_MARCA','$PRINTER_MODEL','$PRINTER_DRIVER') </script>"
		j=$(( $j + 1 ))
	fi
done
echo "<form name='frm' method='get'>"
	echo "<fieldset><legend>New Printer</legend>"
	echo "Printer Name: <input type='text' name='NAME'><br>"
	echo "Select Printer: <select name='URI'>"
	sudo /usr/lib/cups/backend/usb |iconv -c -f UTF-8 -t UTF-8 |cut -d " " -f 2- |sed 's/^\([^ ]*\) "\([^"]*\)" "\([^"]*\)".*/<option value="\1">\3<\/option>/g' |/var/www/lighttpd/cgi/uridecode.pl
	echo "</select><br>"
	echo "Info: <input type='text' name='INFO' value=''><br>"
	echo "Location: <input type='text' name='LOCATION' value=''><br>"
	echo "Driver: <select name='MARCA' id='MARCA_$j' onchange='updateComboModels($j)'>"
	echo "<option value='' selected='selected'>Choose One</option>"
	cat /var/www/lighttpd/drivers/companies.html
	echo "</select>"
	echo "<select name='MODEL' id='MODEL_$j' onchange='updateComboDrivers($j)'>"
	echo "</select>"
	echo "<select name='DRIVER' id='DRIVER_$j'>"
	echo "</select><br>"
	echo "Price Per Page:  <input type='text' name='PRICE' value=''> &euro; cents<br>"
	echo "<input type='submit' name='New' value='Add New Printer'>"
	echo "</fieldset></form>"
echo "</body></html>"
