#include <stdio.h>
#include <stdarg.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#ifdef __unix__
#	include <unistd.h>
#	include <sys/socket.h>
#	include <netinet/in.h>
#	include <netdb.h>
#	include <arpa/inet.h>
#	include <sys/wait.h>
#endif

#ifdef __WIN32__
#	include <windows.h>
#	include <winsock2.h>
#	include <ws2tcpip.h>
#endif

#if !defined(KEY_SENDPAGES)
#	error "KEY_SENDPAGES not defined"
#endif

char *printer_sign(char *key, int id, int pagines, int color);

/**
 * argv[1] => host
 * argv[2] => job id
 * argv[3] => color: 1  b/n : 0
 * argv[4] => num pages
 * argv[5] => num copies
 **/
int main(int argc, char * argv[])
{
	int sockfd, numbytes;
	char buf[128];
	struct addrinfo hints, *servinfo, *p;
	int rv;
	int rId, rStat, ret=-1;

#ifdef __WIN32__
	WSADATA wsaData;
	WSAStartup(MAKEWORD(2,0),&wsaData);
#endif
	if (argc != 6) {
		fprintf(stderr, "Sintax: %s host job-id color num-pages num-copies\n", argv[0]);
		return -1;
	}
	memset(&hints, 0, sizeof hints);
	hints.ai_family = AF_UNSPEC;
	hints.ai_socktype = SOCK_STREAM;

	if ((rv = getaddrinfo(argv[1], "7777", &hints, &servinfo)) != 0) {
		return -1;
	}

	// loop through all the results and connect to the first we can
	for(p = servinfo; p != NULL; p = p->ai_next) {
		if ((sockfd = socket(p->ai_family, p->ai_socktype,
				p->ai_protocol)) == -1) {
			perror("client: socket");
			continue;
		}

		if (connect(sockfd, p->ai_addr, p->ai_addrlen) == -1) {
			close(sockfd);
			perror("client: connect");
			continue;
		}
		break;
	}

	if (p == NULL) {
		return -1;
	}


	freeaddrinfo(servinfo); // all done with this structure

	int num_of_pages;
	int job_id;
	char *sign;
	int color;

	job_id = atoi(argv[2]);
	num_of_pages = atoi(argv[4]);
	color = atoi(argv[3]);
	sign = printer_sign(KEY_SENDPAGES, job_id, num_of_pages, color);

	snprintf(buf,100, "%d,%d,%d,%s\n", job_id, num_of_pages, color, sign);
	free(sign);

	buf[100]=0;
	if (send(sockfd, buf, strlen(buf), 0) < 0) goto SOCK_ERR;

	if ((numbytes = recv(sockfd, buf, 100, 0)) == -1) goto SOCK_ERR;

	buf[numbytes] = '\0';

	if(sscanf(buf,"%d,%d",&rId,&rStat) < 2) goto SOCK_ERR;

	ret = (rStat == 1)?0:-1;
SOCK_ERR:
	close(sockfd);

	return ret;
}
